
import java.util.Random;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import jsc.distributions.Normal;

public class gauss_markov_model { 
	public static Random rnd=new Random();
	public static Random rnd1;
	public static Random speed_rnd;
	public static File dir=new File("gauss_markov");
	public static int max_lat = 5000, 
		      max_long = 5000;
    public static double max_speed=20;
    public static double min_speed=-20;
	public static int limit=0;
	public static double max_distance=50000;
	public static double min_distance=23;
	
static public void main(String args[]) throws Exception {
  int poc=0;
  
  BufferedReader br;
  File segfile=new File("total_Time.txt");
  br = new BufferedReader(new FileReader(segfile));
  String num="";
  String[] tokens;
  num=br.readLine();
  br.close();
  tokens=num.split("[;]+");
  
  if (!dir.exists()) {
		dir.mkdir(); 
  } 
  while (poc!=948){
	  BufferedWriter bw = new BufferedWriter(new FileWriter(new File(dir,"1_"+poc+"_A.txt")));
	  int time=0;
	  int part_time=2;
	  min_speed=-20;
      max_speed=20;
	  int new_lat=0,new_log=0;
      @SuppressWarnings("unused")
	double distance;
      double dp=0,dn,sp=4.2865,sn,alpha=0.45; //sp je priemerna rychlost (dlzka jednej cesty), dp priemerny uhol - meni sa ak je blizsko pri stene o 180 stupnov
      //sn a dn su nahodne premenne z gaussovej distribucie a alfa urcite velkost nahodnosti 0-Brownov pohyb, 1-linearny pohyb
      Normal gdf_s=new Normal(sp,20);   //gauss distribucia
      Normal gdf_d=new Normal(dp,180);   //gauss distribucia
      min_speed=gdf_s.cdf(min_speed);
      max_speed=gdf_s.cdf(max_speed);
	  
      double speed=sp;
      limit=Integer.parseInt(tokens[poc]);
      System.out.println(limit/(double)60);
      int lat=rnd.nextInt(max_lat),log=rnd.nextInt(max_long);
      bw.append(0+"|"+lat+"|"+log+";");
      
      int angle=(int)dp;
      while (time<limit){
    	  sn=gdf_s.inverseCdf(min_speed+Math.random()*(max_speed-min_speed));
      	  dn=gdf_d.inverseCdf(Math.random());
      	
      	  speed=alpha*speed+(1-alpha)*sp+Math.sqrt(1-Math.pow(alpha,2))*sn;
     	  angle=(int)(alpha*angle+(1-alpha)*dp+Math.sqrt(1-Math.pow(alpha,2))*dn);
     	  
     	  new_lat=(int)(lat+speed*Math.cos(Math.toRadians(angle))*part_time);
    	  new_log=(int)(log+speed*Math.sin(Math.toRadians(angle))*part_time);
     	  distance=Distance(lat,log,new_lat,new_log);
     	  
     	  if (time+part_time<=limit) {
			time+=part_time;
		  }
		  else {
			double part=(limit-time)/(double)part_time;
  			new_lat=(int)(lat+(new_lat-lat)*part);
  			new_log=(int)(log+(new_log-log)*part);
  			part_time=(limit-time);
  			time=limit;
		  }
		  bw.append(part_time+"|"+new_lat+"|"+new_log+";");
		  lat=new_lat;
		  log=new_log;
	 }
      bw.close();
      System.out.println(poc);
      poc++;
 }
}

//metoda rata vzdialenost medzi A a B
	private static double Distance(double pointA_x,double pointA_y, double pointB_x,double pointB_y)
	{
	    double d1 = pointA_x - pointB_x;
	    double d2 = pointA_y - pointB_y;

	    return Math.sqrt(d1 * d1 + d2 * d2);
	}
}