
import java.util.Random;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import jsc.distributions.Pareto;

public class levy_walk { 
	public static Random rnd=new Random();
	public static Random rnd1;
	public static Random speed_rnd;
	public static File dir=new File("levy_walk");
	public static int max_lat = 5000, 
		      max_long = 5000;
	public static int limit=0;
	public static double max_distance=3000;
	public static double min_distance=2;
	
static public void main(String args[]) throws Exception {
  int poc=0;
  if (!dir.exists()) {
		dir.mkdir(); 
  } 
  max_lat=5000; max_long=5000;
	  
  BufferedReader br;
  File segfile=new File("total_Time.txt");
  br = new BufferedReader(new FileReader(segfile));
  String num="";
  String[] tokens;
  num=br.readLine();
  br.close();
  tokens=num.split("[;]+");
  
  while (poc<948){
	  BufferedWriter bw = new BufferedWriter(new FileWriter(new File(dir,"1_"+poc+"_A.txt")));
  	  int time=0;
	  int part_time=0;
      int new_lat=0,new_log=0;
      max_distance=3000;
      min_distance=23;
      double distance;
      rnd1 = new Random();
      speed_rnd = new Random();
      limit=Integer.parseInt(tokens[poc]);
      int lat=rnd.nextInt((int)max_lat),log=rnd.nextInt((int)max_long);
      Pareto pdf=new Pareto(22.2567,0.9020);   //levy walk, paretova distribucia location/scale  shape
      min_distance=pdf.cdf(min_distance);   //vacsie alebo rovne ako location v distribucii!!!!
      max_distance=pdf.cdf(max_distance);  
      
      bw.append(0+"|"+lat+"|"+log+";");
  
      int angle,a,b=0;
      int[] temp;
      while (time<limit){
    	  distance=pdf.inverseCdf(min_distance+Math.random()*(max_distance-min_distance));
    	  if (distance<500){
    		  part_time=(int)(30.55*Math.pow(distance, (1-0.89)));
    	  } else {
    		  part_time=(int)(0.76*Math.pow(distance, (1-0.28)));
    	  } 
    	  
          angle=rnd1.nextInt(359);
          temp=getab((int)distance,angle);
          a=temp[0];b=temp[1];
          new_lat=(int)(lat+a);
          new_log=(int)(log+b);
		  if (time+part_time<=limit) {
			time+=part_time;
		  }
		  else {
			double part=(limit-time)/(double)part_time;
  			new_lat=(int)(lat+(new_lat-lat)*part);
  			new_log=(int)(log+(new_log-log)*part);
  			part_time=(limit-time);
  			time=limit;
		  }
		  bw.append(part_time+"|"+new_lat+"|"+new_log+";");
		  lat=new_lat;
		  log=new_log;
	 }
      bw.close();
      System.out.println(poc);
      poc++;
 }
}


//podla uhlu, v ktorom sme kvartali na jednotkovej kruznici zistime ci sa posuvame smerom + alebo - a o kolko
public static int[] getab(int length,int angle){
	  double a=0,b=0;
	  if (angle<90){
  	  a=-length*Math.sin(Math.toRadians(angle));
  	  b=length*Math.cos(Math.toRadians(angle));
    } else if (angle<180){
  	  a=-length*Math.sin(Math.toRadians(180-angle));
  	  b=-length*Math.cos(Math.toRadians(180-angle));
    } else if (angle<270){
  	  a=length*Math.sin(Math.toRadians(angle-180));
  	  b=-length*Math.cos(Math.toRadians(angle-180));
    } else {
  	  a=length*Math.sin(Math.toRadians(360-angle));
  	  b=length*Math.cos(Math.toRadians(360-angle));
    }
	  int[] result={(int)a,(int)b};
	  return result;
}

}