import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

public class neighbours {
public static int file=0;
public static int variance=25;
public static int limit=(60*60);
public static int sub=948;
public static int segment=0;
public static File dir;
private static ArrayList<gpsPoint> points=new ArrayList<gpsPoint>();
public static ArrayList<gpsPoint> final_points=new ArrayList<gpsPoint>();


	//ratame vzdialenost medzi bodom A a B
	private static double Distance(double[] pointA, double[] pointB)
	{
	    double d1 = pointA[0] - pointB[0];
	    double d2 = pointA[1] - pointB[1];

	    return Math.sqrt(d1 * d1 + d2 * d2);
	}


public static class gpsPoint{
	private double lat;
	private double log;
	private int time;
	private int source;
	
	public gpsPoint(int time, double lat,double log){
		this.time=time;
		this.lat=lat;
		this.log=log;
	}
	
	public gpsPoint(int time, double lat,double log, int source){
		this.time=time;
		this.lat=lat;
		this.log=log;
		this.source=source;
	}
	
	public void setLog(double log){
		this.log=log;
	}
	public void setLat(double lat){
		this.lat=lat;
	}
	public void setSource(int source){
		this.source=source;
	}
	public double getLog(){
		return this.log;
	}
	public double getLat(){
		return this.lat;
	}
	public int getTime(){
		return this.time;
	}
	public int getSource(){
		return this.source;
	}
}

public static void main(String[] args) throws Exception {
	
	dir = new File ("ACRM_model");
	File actualFile1 = new File (dir,"total_Neigh_"+limit+"_"+dir.getName()+".txt");
	BufferedWriter bwr=new BufferedWriter(new FileWriter(actualFile1));
    //pre vsetky body zratame kam sa dostanu po 5/15/30/60 minutach (@limit) a tento bod zapiseme do arraylistu final_points
	File temp_file;
	for (int j=0;j<sub;j++){
		temp_file=new File(dir,file+"_"+j+"_A.txt");
		if (!temp_file.exists()) file++;
		read_points("_A",file+"_"+j);
    }
	double[] AA=new double[2];
    double[] BB=new double[2];
    int neigh;
    //pozreme sa na vsetky final_points a spocitam kolko uzlov je v mojom okoli @variance
    for (int i=0;i<sub;i++){ 
  	  neigh=0;
	  AA[0]=final_points.get(i).getLat();
	  AA[1]=final_points.get(i).getLog();
  	  for (int j=0;j<sub;j++){
  		  if (i==j) continue; else{
  		  BB[0]=final_points.get(j).getLat();
  		  BB[1]=final_points.get(j).getLog();
  		  if (Distance(AA,BB)<=variance){
  			  neigh++;
  		  }
  		  }
  	  }
  	  bwr.append(""+neigh+";");
  	  System.out.print(i+" "+neigh);
    }
    bwr.close();
}

public static void read_points(String dopl,String number) throws Exception{
		points.clear();
		BufferedReader br;
		File segfile=new File(dir,number+""+dopl+".txt");
        br = new BufferedReader(new FileReader(segfile));
    	String num="";
    	String[] tokens;
    	num=br.readLine();
    	br.close();
    	tokens=num.split("[;]+");
    	int j=0;
    	int total_time=0;
    	String[] temp;
    	double lat_old=0,log_old=0;
    	double lat=0,log=0;
    	while(j<tokens.length){
    		temp=tokens[j].split("[|]+");
    		if (temp.length==3){
    			int time=Integer.parseInt(temp[0]);
    		    lat=Double.parseDouble(temp[1]);
    		    log=Double.parseDouble(temp[2]);
    		    if (total_time+time<limit){
        			total_time+=time;
        		} else {
        			double part=(limit-total_time)/time;
        			double lat_part=lat_old+((lat-lat_old)*part);
        			double long_part=log_old+((log-log_old)*part);
        			total_time=limit;
        			final_points.add(new gpsPoint(total_time,lat_part,long_part,file));
        			return;
        		}
    		}
    		lat_old=lat;
    		log_old=log;
    		j++;
    	}
    	if (total_time<limit) final_points.add(new gpsPoint(total_time,lat,log));	
	}
}