import java.util.Random;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class probabilistic_chiang_model { 
	public static Random rnd=new Random();
	public static Random rnd1;
	public static File dir=new File("prb_chiang_model");
	public static int max_lat = 5000, 
		      max_long = 5000;
	public static int limit=0;
	public static int[] state=new int[2]; 
	
static public void main(String args[]) throws Exception {
  int poc=0;
  
  BufferedReader br;
  File segfile=new File("total_Time.txt");
  br = new BufferedReader(new FileReader(segfile));
  String num="";
  String[] tokens;
  num=br.readLine();
  br.close();
  tokens=num.split("[;]+");
  
  if (!dir.exists()) {
		dir.mkdir(); 
  } 
  while (poc<948){
	  BufferedWriter bw = new BufferedWriter(new FileWriter(new File(dir,"1_"+poc+"_A.txt")));
	  int time=0;
	  int part_time=0;
      double speed=4.2865; //NASTAVENE PODLA PRIEMERU DAT
      int distance=10;
      rnd1 = new Random();
      limit=Integer.parseInt(tokens[poc]);
      int lat=rnd.nextInt(max_lat),log=rnd1.nextInt(max_long);
      int old_lat=lat-distance;
      int old_log=log-distance;
      int new_lat=lat+distance;
      int new_log=log+distance;
      bw.append(0+"|"+lat+"|"+log+";");
      state[0]=0;state[1]=0;
      int a,b;
      while (time<limit){
    	  a=stepAB(old_lat,lat,new_lat,Math.random(),0);
    	  old_lat=lat;lat+=a;new_lat=lat+a;
    	  b=stepAB(old_log,log,new_log,Math.random(),1);
    	  old_log=log;log+=b;new_log=log+b;
          part_time=((int)Math.floor(distance/(double)speed));
		  if (time+part_time<=limit) {
			time+=part_time;
		  }
		  else {
			double part=(limit-time)/(double)part_time;
  			lat=(int)(old_lat+(lat-old_lat)*part);
  			log=(int)(old_log+(log-old_log)*part);
  			part_time=(limit-time);
  			time=limit;
		  }
		  bw.append(part_time+"|"+lat+"|"+log+";");
	 }
      bw.close();
      System.out.println(poc);
      poc++;
 }
}


//stavovy automat pre chiangov model pohybu @st urcuje, ci sa pohybujeme v automate premennej X alebo Y, 
//@s0,@s1,@s2 su hodnoty lokacie v stave 0, 1, 2
public static int stepAB(int s1,int s0, int s2,double prb,int st){ 
	int result=100;
	  if(state[st]==0){
		  if(prb<0.5){
			  result=s1-s0;
			  state[st]=1;
		  } else {
			  result=s2-s0;
			  state[st]=2;
		  }
	  } else if (state[st]==1){
		  if(prb<0.7){
			  result=s2-s0;
			  state[st]=1;
		  } else {
			  result=s1-s0;
			  state[st]=0;
		  }
	  } else if (state[st]==2){
		  if(prb<0.7){
			  result=s2-s0;
			  state[st]=2;
		  } else {
			  result=s1-s0;
			  state[st]=0;
		  }
	  }
	  return result;
}

}